
if CLIENT then

end

if !ConVarExists("sv_npccanfall") then
    CreateConVar("sv_npccanfall", '1', FCVAR_NOTIFY)
end

if !ConVarExists("sv_npcworlddamagedivider") then
    CreateConVar("sv_npcworlddamagedivider", '20', FCVAR_NOTIFY)
end

if !ConVarExists("sv_npcwaketime") then
    CreateConVar("sv_npcwaketime", '3', FCVAR_NOTIFY)
end

if !ConVarExists("sv_npcupspeed") then
    CreateConVar("sv_npcupspeed", '250', FCVAR_NOTIFY)
end
local MFallingSound = {
"vo/npc/male01/no02.wav",
"vo/npc/male01/no01.wav",
"vo/npc/male01/help01.wav",
"vo/npc/male01/moan04.wav",
"vo/npc/male01/uhoh.wav",
"vo/npc/male01/ohno.wav",
"vo/npc/male01/watchout.wav",
"vo/npc/male01/goodgod.wav"}

local MWakeSound = {
"vo/npc/male01/moan03.wav",
"vo/npc/male01/moan04.wav",
"vo/npc/male01/moan05.wav",}

local MRagdollHurtSound = {
"vo/npc/male01/pain01.wav",
"vo/npc/male01/pain02.wav",
"vo/npc/male01/pain03.wav",
"vo/npc/male01/pain04.wav",
"vo/npc/male01/pain05.wav",
"vo/npc/male01/pain06.wav",
"vo/npc/male01/pain07.wav",
"vo/npc/male01/pain08.wav",
"vo/npc/male01/pain09.wav",
"vo/npc/male01/startle01.wav",
"vo/npc/male01/startle02.wav",}

local FFallingSound = {
"vo/npc/female01/no02.wav",
"vo/npc/female01/no01.wav",
"vo/npc/female01/help01.wav",
"vo/npc/female01/moan04.wav",
"vo/npc/female01/uhoh.wav",
"vo/npc/female01/ohno.wav",
"vo/npc/female01/watchout.wav",
"vo/npc/female01/goodgod.wav"}

local FRagdollHurtSound = {
"vo/npc/female01/pain01.wav",
"vo/npc/female01/pain02.wav",
"vo/npc/female01/pain03.wav",
"vo/npc/female01/pain04.wav",
"vo/npc/female01/pain05.wav",
"vo/npc/female01/pain06.wav",
"vo/npc/female01/pain07.wav",
"vo/npc/female01/pain08.wav",
"vo/npc/female01/pain09.wav",
"vo/npc/female01/startle01.wav",
"vo/npc/female01/startle02.wav",}

local FWakeSound = {
"vo/npc/female01/moan03.wav",
"vo/npc/female01/moan04.wav",
"vo/npc/female01/moan05.wav",}

local NextHurt = CurTime() 
	
local BreakBone = {
"physics/body/body_medium_break2.wav",
"physics/body/body_medium_break3.wav"}

local NotHuman = {
"npc_headcrab",
"npc_headcrab_fast",
"npc_manhack",
"npc_cscanner",
"npc_hunter",
"npc_antlion",
"npc_antlionguard",
"npc_seagull",
"npc_crow",
"npc_pigeon",
"npc_antlion_worker"}

local CantSound = {
"npc_zombie",
"npc_zombie_torso",
"npc_zombine",
"npc_dog",
"npc_vortigaunt",
"npc_fastzombie_torso",
"npc_poisonzombie",
"npc_fastzombie"}

local CantDo = {
"npc_turret_floor",
"npc_rollermine"}

if (SERVER) then 

function NpcFalling(ent)
    if ent:GetNWBool("NpcFalling") or table.HasValue( CantDo, ent:GetClass() ) then return end   
	
    ent.LastHealth = ent:Health()
	ent.LastClass = ent:GetClass()
	ent.LastMoveType = ent:GetMoveType()
	
    local Body = ents.Create("prop_ragdoll")
		Body:SetPos(ent:GetPos())
		Body:SetAngles(ent:GetAngles())
		Body:SetModel(ent:GetModel())
		Body.Owner = ent
		Body:Spawn()
		Body:Activate()
		local plyvel = ent:GetVelocity()

		for i = 1, Body:GetPhysicsObjectCount() do
			local bone = Body:GetPhysicsObjectNum(i)
		
			if bone and bone.IsValid and bone:IsValid() then
				local bonepos, boneang = ent:GetBonePosition(Body:TranslatePhysBoneToBone(i))
			
			bonepos = bonepos - Vector(0,0,50)
	
				bone:SetPos(bonepos)
				bone:SetAngle(boneang)
			
				bone:AddVelocity(plyvel)
			end
		end

		Body:SetCollisionGroup(COLLISION_GROUP_WEAPON)
		Body:SetNetworkedString("Owner", "World")
		Body:SetNWBool("NpcFallingEnt", true)
		
	if !table.HasValue( NotHuman, ent:GetClass() ) then
		if ent.Male == true and !table.HasValue( CantSound, ent:GetClass() ) then
		Body:EmitSound(table.Random(MFallingSound))
		elseif ent.Male == false and !table.HasValue( CantSound, ent:GetClass() ) then
		Body:EmitSound(table.Random(FFallingSound))
		end
		Body:SetNetworkedEntity("BodyNpc", ent)
	ent:SetNWBool("NpcFalling", true)
	ent:SetNoDraw(true)
	ent:SetPos(Vector(0,0,-9999))
	ent:SetNetworkedEntity("NpcFalling", Body)
	else
	ent:Remove()
	end
	
end

function NpcFallingReset(ent)
if !ent:GetNWBool("NpcFalling") then return end
local Body = ent:GetNetworkedEntity("NpcFalling")
local NpcBody = Body:GetNetworkedEntity("BodyNpc")

local trace = {}
	trace.start = Body:GetPos()
	trace.endpos = trace.start + Vector(0,0,-30)
	trace.filter = Body
	local tr = util.TraceLine( trace )

	if ent.Died == false then
	ent:SetMoveType(ent.LastMoveType)
    NpcBody:SetNoDraw(false)	
    ent:SetPos(tr.HitPos + Vector(0,0,10))
    ent:SetHealth(ent.LastHealth)
    ent:SetNWBool("NpcFalling", false)
    ent.FixShit = CurTime() + 1
    Body:Remove()
	else
	ent:Remove()
	Body:Fire("kill", "", 15)
    end
end

local UpValue = 0
function NpcFallingThink()
 if GetConVarNumber("sv_npccanfall") == 0 then return end
for k, v in pairs(ents.GetAll()) do
if v:IsNPC() then 
local Body = v:GetNetworkedEntity("NpcFalling")

  if !v:GetNWBool("NpcFalling") and v.FixShit and v.FixShit < CurTime() then
  local npctrace = {}
  npctrace.start = v:GetPos()
  npctrace.endpos = npctrace.start + Vector(0,0,-999999)
  npctrace.filter = v
  local npctr = util.TraceLine( npctrace )
  local dist = npctr.HitPos:Distance(v:GetPos())
  
  if v:GetVelocity():Length() > 500 and dist > 200 then
  NpcFalling(v)
  end
  elseif v:GetNWBool("NpcFalling") and Body:IsValid() then
  
  if !table.HasValue( NotHuman, v:GetClass() ) then
  if Body:GetVelocity():Length() > 500 then
  v.ResetTime = CurTime() + GetConVarNumber("sv_npcwaketime")
  v.CanUp = false
  elseif Body:GetVelocity():Length() < 500 and v.Died != true and v.CanUp == false and v.ResetTime and v.ResetTime < CurTime() then
  v.CanUp = true
 if v.Male == true and !table.HasValue( CantSound, v:GetClass() ) then
		Body:EmitSound(table.Random(MWakeSound))
		elseif v.Male == false and !table.HasValue( CantSound, v:GetClass() ) then
		Body:EmitSound(table.Random(FWakeSound))
		end
  end
  local head = Body:GetPhysicsObjectNum( Body:TranslateBoneToPhysBone( Body:LookupBone( "ValveBiped.Bip01_Head1" ) ) )
  if head == nil then return end
  if v.CanUp == true then
	if UpValue >= 0 and UpValue < 850 then
	UpValue = math.Approach(UpValue, 850, FrameTime() * GetConVarNumber("sv_npcupspeed"))
	v.CanUp = true
	head:SetDamping( 0, 400 )
	head:ApplyForceCenter( Vector(0,0,1) * UpValue )
	elseif UpValue == 850 then
	v.Upped = true
	head:SetDamping( 0, 0 )
	end
	else
	UpValue = 0
	v.Upped = false
	end
 
if v.Upped == true then
NpcFallingReset(v)
end
end
end
end  
end
end
hook.Add("Think","NpcFallingThink",NpcFallingThink)

function NpcFallingInit(ent)

    if !ent:IsNPC() then return end
	ent.CanUp = true
	ent.ResetTime = CurTime() + 3
	ent.FixShit = CurTime() + 1
	ent.Died = false
	 ent.Male = true
	
	timer.Simple(0.1, function()
	if string.find(ent:GetModel(), "alyx.mdl") or string.find(ent:GetModel(), "mossman.mdl") or string.find(ent:GetModel(), "female_01.mdl") or string.find(ent:GetModel(), "female_02.mdl") or string.find(ent:GetModel(), "female_03.mdl") or string.find(ent:GetModel(), "female_04.mdl") or string.find(ent:GetModel(), "female_05.mdl") or string.find(ent:GetModel(), "female_06.mdl") or string.find(ent:GetModel(), "female_07.mdl") then
		ent.Male = false
	end
	
	end, ent) 
 
end
hook.Add("OnEntityCreated", "NpcFallingInit", NpcFallingInit )

local amount1
function FallingNpcTakeDamage( ent, inflictor, attacker, amount, dmginfo )

	for k, v in pairs(ents.GetAll()) do
	local Body = v:GetNetworkedEntity("NpcFalling")
		if v:GetNWBool("NpcFalling") and Body:IsValid() then 

			if ent != Body then return end
			local dmgtype   = dmginfo:GetDamageType() 
			if attacker:IsWorld() then
			amount1 = ( dmginfo:GetDamage() / GetConVarNumber("sv_npcworlddamagedivider") )
			else
			amount1 = dmginfo:GetDamage() 
			end
			local dmgpos 	= dmginfo:GetDamagePosition()
			local dmgtype 	= dmginfo:GetDamageType()
			local norm 		= ent:GetVelocity():GetNormalized()
			
			local CurHealth = v.LastHealth
			local HealthModifier = CurHealth - amount1 
			
			v.LastHealth = math.Clamp(HealthModifier,0,v:GetMaxHealth())
			v:SetHealth(v.LastHealth)
			
			if v.LastHealth > 0 and amount > 15 and NextHurt < CurTime() then
			NextHurt = CurTime() + 0.15
			/*
			if !table.HasValue( CantSound, v:GetClass() ) then
			if ent.Male == true then
			ent:EmitSound(table.Random(MRagdollHurtSound))
			elseif ent.Male == false then
			ent:EmitSound(table.Random(FRagdollHurtSound))
			end
			end
			*/
			if amount > 25 then
			ent:EmitSound(table.Random(BreakBone))
			end
			end
			
			if v.LastHealth <= 0 and v.Died == false then
			v.Died = true
			NpcFallingReset(v)
			end
		
		end
	end

end
hook.Add( "EntityTakeDamage", "FallingNpcTakeDamage", FallingNpcTakeDamage )

end

